(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('primeng/components/common/messageservice'), require('@angular/router'), require('lodash'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('@devatscience/ngx-errors', ['exports', '@angular/core', 'primeng/components/common/messageservice', '@angular/router', 'lodash', '@angular/common/http'], factory) :
    (global = global || self, factory((global.devatscience = global.devatscience || {}, global.devatscience['ngx-errors'] = {}), global.ng.core, global.messageservice, global.ng.router, global.lodash, global.ng.common.http));
}(this, function (exports, core, messageservice, router, lodash, http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var ErrorHandlerService = /** @class */ (function () {
        function ErrorHandlerService(messageService) {
            this.messageService = messageService;
            this._console = console;
        }
        ErrorHandlerService.prototype.handleError = function (error) {
            var errorLogger = this.getErrorLogger(error);
            var original = this.getOriginalError(error);
            var context = this.getDebugContext(error);
            var message = (original || error).message || "" + error;
            errorLogger(this._console, 'ERROR', message);
            if (original) {
                errorLogger(this._console, 'ORIGINAL ERROR', original);
            }
            if (context) {
                errorLogger(this._console, 'CONTEXT', context);
            }
            this.messageService.add({
                severity: 'error',
                summary: (original || error).constructor.name,
                detail: message,
                life: 15,
                closable: true,
                data: error,
            });
        };
        ErrorHandlerService.prototype.getDebugContext = function (error) {
            return error
                ? error.ngDebugContext ||
                    this.getDebugContext(this.getOriginalError(error))
                : null;
        };
        ErrorHandlerService.prototype.getOriginalError = function (error) {
            var original = error;
            while (original) {
                original = original.ngOriginalError;
            }
            return original;
        };
        ErrorHandlerService.prototype.getErrorLogger = function (error) {
            return error.ngErrorLogger || this.defaultErrorLogger;
        };
        ErrorHandlerService.prototype.defaultErrorLogger = function (console) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                values[_i - 1] = arguments[_i];
            }
            console.error.apply(console, __spread(values));
        };
        ErrorHandlerService.ctorParameters = function () { return [
            { type: messageservice.MessageService }
        ]; };
        ErrorHandlerService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [messageservice.MessageService])
        ], ErrorHandlerService);
        return ErrorHandlerService;
    }());

    var GenericErrorComponent = /** @class */ (function () {
        function GenericErrorComponent() {
        }
        GenericErrorComponent = __decorate([
            core.Component({
                selector: 'lib-generic-error',
                template: "<div class=\"card ui-message ui-messages-error\">\n  <h1>\n    <i class=\"ui-messages-icon fa fa-exclamation-triangle\"></i>\n    <span i18n class=\"ui-messages-summary\">Erreur !</span>\n  </h1>\n  <p i18n class=\"ui-messages-detail\">Une erreur s'est produite !</p>\n</div>\n"
            })
        ], GenericErrorComponent);
        return GenericErrorComponent;
    }());

    var NotFoundErrorComponent = /** @class */ (function () {
        function NotFoundErrorComponent() {
        }
        NotFoundErrorComponent = __decorate([
            core.Component({
                selector: 'lib-not-found-error',
                template: "<div class=\"card ui-message ui-messages-error\">\n  <h1>\n    <i class=\"ui-messages-icon fa fa-exclamation-triangle\"></i>\n    <span i18n class=\"ui-messages-summary\">Page non trouv\u00E9e !</span>\n  </h1>\n  <p i18n class=\"ui-messages-detail\">La ressource n'a pas \u00E9t\u00E9 trouv\u00E9e.</p>\n</div>\n"
            })
        ], NotFoundErrorComponent);
        return NotFoundErrorComponent;
    }());

    var routes = [
        {
            path: 'error/404',
            pathMatch: 'full',
            component: NotFoundErrorComponent,
        },
        { path: 'error/**', component: GenericErrorComponent },
    ];
    var ErrorModule = /** @class */ (function () {
        function ErrorModule() {
        }
        ErrorModule = __decorate([
            core.NgModule({
                imports: [router.RouterModule.forChild(routes)],
                exports: [router.RouterModule],
                providers: [{ provide: core.ErrorHandler, useClass: ErrorHandlerService }],
                declarations: [GenericErrorComponent, NotFoundErrorComponent],
            })
        ], ErrorModule);
        return ErrorModule;
    }());

    function isErrorMessageHandler(that) {
        return lodash.hasIn(that, 'setError') && lodash.isFunction(that.setError);
    }
    function isConstraintViolationHandler(that) {
        return (lodash.hasIn(that, 'setConstraintViolations') &&
            lodash.isFunction(that.setConstraintViolations));
    }
    function isValidationErrorHandler(that) {
        return lodash.hasIn(that, 'setErrors') && lodash.isFunction(that.setErrors);
    }
    function isErrorLogger(that) {
        return lodash.hasIn(that, 'logError') && lodash.isFunction(that.logError);
    }
    function isErrorHandler(that) {
        return (isErrorMessageHandler(that) ||
            isConstraintViolationHandler(that) ||
            isValidationErrorHandler(that) ||
            isErrorLogger(that));
    }
    function isErrorClearer(that) {
        return lodash.hasIn(that, 'clearErrors') && lodash.isFunction(that.clearErrors);
    }
    function isDispatchableError(that) {
        return lodash.hasIn(that, 'dispatch') && lodash.isFunction(that.dispatch);
    }

    /**
     * Erreur "enveloppant" une autre erreur.
     */
    var AppError = /** @class */ (function () {
        function AppError(original, message, stack, transient) {
            if (transient === void 0) { transient = false; }
            this.original = original;
            this.message = message;
            this.stack = stack;
            this.transient = transient;
            this.isNullError = false;
        }
        Object.defineProperty(AppError.prototype, "name", {
            get: function () {
                return this.getName();
            },
            enumerable: true,
            configurable: true
        });
        AppError.prototype.dispatch = function (handler) {
            return ((isErrorLogger(handler) &&
                handler.logError(this.message, this.name, this.stack)) ||
                (isErrorMessageHandler(handler) && handler.setError(this.message)) ||
                (isValidationErrorHandler(handler) &&
                    handler.setErrors({ message: this.message })));
        };
        AppError.prototype.getName = function () {
            return ((this.original instanceof Error && this.original.name) ||
                this.constructor.name);
        };
        return AppError;
    }());

    /**
     * Supprime les erreurs d'un handler.
     */
    function clearErrors(handler) {
        if (isErrorClearer(handler) && handler.clearErrors()) {
            return true;
        }
        var handled = false;
        if (isErrorMessageHandler(handler) && handler.setError(null)) {
            handled = true;
        }
        if (isValidationErrorHandler(handler) && handler.setErrors(null)) {
            handled = true;
        }
        if (isConstraintViolationHandler(handler) &&
            handler.setConstraintViolations(null)) {
            handled = true;
        }
        return handled;
    }

    /**
     * Erreur basée sur une réponse HTTP d'erreur.
     */
    var HTTPError = /** @class */ (function (_super) {
        __extends(HTTPError, _super);
        function HTTPError(original, message) {
            return _super.call(this, original, message || original.message || original.statusText, undefined, original.status >= 500) || this;
        }
        Object.defineProperty(HTTPError.prototype, "status", {
            get: function () {
                return this.original.status;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "statusText", {
            get: function () {
                return this.original.statusText;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "headers", {
            get: function () {
                return this.original.headers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "url", {
            get: function () {
                return this.original.url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HTTPError.prototype, "error", {
            get: function () {
                return this.original.error;
            },
            enumerable: true,
            configurable: true
        });
        return HTTPError;
    }(AppError));
    /**
     * Erreur 403: Forbidden
     */
    var AccessDeniedError = /** @class */ (function (_super) {
        __extends(AccessDeniedError, _super);
        function AccessDeniedError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AccessDeniedError;
    }(HTTPError));
    /**
     * Erreur 401: Authentication Required
     */
    var AuthenticationError = /** @class */ (function (_super) {
        __extends(AuthenticationError, _super);
        function AuthenticationError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AuthenticationError;
    }(HTTPError));
    /**
     * Erreur 400: Bad Request
     */
    var BadRequestError = /** @class */ (function (_super) {
        __extends(BadRequestError, _super);
        function BadRequestError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return BadRequestError;
    }(HTTPError));

    /**
     * Erreur de validation retournée par api-platform.
     */
    var ConstraintViolations = /** @class */ (function (_super) {
        __extends(ConstraintViolations, _super);
        function ConstraintViolations(original, message, violations) {
            var _this = _super.call(this, original, message) || this;
            _this.violations = violations;
            return _this;
        }
        ConstraintViolations.prototype.dispatch = function (handler) {
            return ((isConstraintViolationHandler(handler) &&
                handler.setConstraintViolations(this.violations)) ||
                _super.prototype.dispatch.call(this, handler));
        };
        ConstraintViolations.create = function (violations) {
            return new ConstraintViolations(new http.HttpErrorResponse({
                status: 400,
                statusText: 'Constraint violations',
            }), 'Constraint violations', violations);
        };
        return ConstraintViolations;
    }(BadRequestError));

    var ɵ0 = function (handler) {
        return clearErrors(handler);
    };
    /**
     * Singleton d'erreur null.
     */
    var NullError = {
        isNullError: true,
        name: 'NullError',
        message: 'No error',
        dispatch: ɵ0,
    };

    /**
     * Transforme une valeur en erreur.
     *
     * Les informations intéressantes d'HttpErrorResponse et Error sont conservés.
     */
    function normalizeError(err) {
        if (err instanceof AppError || err === NullError) {
            return err;
        }
        if (err instanceof http.HttpErrorResponse) {
            return normalizeHttpErrorResponse(err);
        }
        if (err instanceof Error) {
            return new AppError(err, err.message, err.stack, false);
        }
        if (lodash.isEmpty(err)) {
            return NullError;
        }
        if (typeof err === 'object') {
            return new AppError(err, extractMessage(err), err.stack, err.transient || false);
        }
        return new AppError(err, extractMessage(err));
    }
    function normalizeHttpErrorResponse(err) {
        var body = 'error' in err ? err.error : {};
        var message = extractMessage(body) || extractMessage(err);
        switch (err.status) {
            case 400:
                if (lodash.has(body, 'violations') && lodash.isArray(body.violations)) {
                    return new ConstraintViolations(err, message, body.violations);
                }
                return new BadRequestError(err, message);
            case 401:
                return new AuthenticationError(err, message);
            case 403:
                return new AccessDeniedError(err, message);
            default:
                return new HTTPError(err, message);
        }
    }
    function extractMessage(err) {
        if (!err) {
            return undefined;
        }
        switch (typeof err) {
            case 'object':
                if ('message' in err) {
                    return err.message;
                }
                if ('hydra:description' in err) {
                    return err['hydra:description'];
                }
                if ('hydra:title' in err) {
                    return err['hydra:title'];
                }
                if ('error' in err) {
                    return extractMessage(err.error);
                }
                break;
            case 'string':
            case 'number':
                return "" + err;
        }
        return undefined;
    }

    /**
     * Erreur émise lorsqu'une exception ne peut pas être dispatchée.
     */
    var UnhandledError = /** @class */ (function (_super) {
        __extends(UnhandledError, _super);
        function UnhandledError(original) {
            return _super.call(this, original, "Unhandled error: " + original.message, original.stack, false) || this;
        }
        return UnhandledError;
    }(AppError));

    var ValidationError = /** @class */ (function (_super) {
        __extends(ValidationError, _super);
        function ValidationError(errors) {
            var _this = _super.call(this, errors, errors.message || 'Validation error') || this;
            _this.errors = errors;
            return _this;
        }
        ValidationError.prototype.dispatch = function (handler) {
            return ((isValidationErrorHandler(handler) && handler.setErrors(this.errors)) ||
                _super.prototype.dispatch.call(this, handler));
        };
        return ValidationError;
    }(AppError));

    exports.AccessDeniedError = AccessDeniedError;
    exports.AppError = AppError;
    exports.AuthenticationError = AuthenticationError;
    exports.BadRequestError = BadRequestError;
    exports.ConstraintViolations = ConstraintViolations;
    exports.ErrorHandlerService = ErrorHandlerService;
    exports.ErrorModule = ErrorModule;
    exports.GenericErrorComponent = GenericErrorComponent;
    exports.HTTPError = HTTPError;
    exports.NotFoundErrorComponent = NotFoundErrorComponent;
    exports.NullError = NullError;
    exports.UnhandledError = UnhandledError;
    exports.ValidationError = ValidationError;
    exports.clearErrors = clearErrors;
    exports.isConstraintViolationHandler = isConstraintViolationHandler;
    exports.isDispatchableError = isDispatchableError;
    exports.isErrorClearer = isErrorClearer;
    exports.isErrorHandler = isErrorHandler;
    exports.isErrorLogger = isErrorLogger;
    exports.isErrorMessageHandler = isErrorMessageHandler;
    exports.isValidationErrorHandler = isValidationErrorHandler;
    exports.normalizeError = normalizeError;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=devatscience-ngx-errors.umd.js.map
